

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.learn.nn.bpn &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../../index.html"/>
        <link rel="up" title="Module code" href="../../../index.html"/> 

  
  <script src="../../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.learn.nn.bpn</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.learn.nn.bpn</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">from</span> <span class="nn">d2o.learn.nn</span> <span class="kn">import</span> <span class="n">transfer_functions</span> <span class="k">as</span> <span class="n">tfs</span>
<span class="kn">from</span> <span class="nn">d2o.utils</span> <span class="kn">import</span> <span class="n">logger</span> <span class="k">as</span> <span class="n">log</span>
<span class="kn">from</span> <span class="nn">d2o.utils</span> <span class="kn">import</span> <span class="n">calc</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>

<div class="viewcode-block" id="BackpropagationNetwork"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.bpn.BackpropagationNetwork">[docs]</a><span class="k">class</span> <span class="nc">BackpropagationNetwork</span><span class="p">:</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  Simple Neural network utilizing the back propagation (error-propagation) method.</span>
<span class="sd">  TODO: Can be replaced by MXNET, Tensorflow, Caffe etc.</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">input_mask</span><span class="p">,</span> <span class="n">target_mask</span><span class="p">,</span> <span class="n">num_hidden</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">zero_band</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
    <span class="c1"># Network info</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">zero_band</span> <span class="o">=</span> <span class="n">zero_band</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">num_hidden</span> <span class="o">=</span> <span class="n">num_hidden</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">target_mask</span> <span class="o">=</span> <span class="n">target_mask</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">input_mask</span> <span class="o">=</span> <span class="n">input_mask</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">input_scaler</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">output_scaler</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">scalers_fitted</span> <span class="o">=</span> <span class="bp">False</span>

    <span class="n">hidden_sizes</span> <span class="o">=</span> <span class="n">calc</span><span class="o">.</span><span class="n">exponential_decay</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">input_mask</span><span class="p">)</span> <span class="o">+</span> <span class="nb">len</span><span class="p">(</span><span class="n">target_mask</span><span class="p">),</span> <span class="bp">self</span><span class="o">.</span><span class="n">num_hidden</span><span class="p">,</span> <span class="n">decay_rate</span><span class="o">=</span><span class="mf">0.5</span><span class="p">)</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">hidden_sizes</span> <span class="o">=</span> <span class="p">[</span><span class="nb">int</span><span class="p">(</span><span class="n">x</span><span class="p">)</span><span class="o">+</span><span class="mi">1</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">hidden_sizes</span><span class="p">]</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">shape</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">([</span><span class="nb">len</span><span class="p">(</span><span class="n">input_mask</span><span class="p">)]</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">hidden_sizes</span> <span class="o">+</span> <span class="p">[</span><span class="nb">len</span><span class="p">(</span><span class="n">target_mask</span><span class="p">)])</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">num_layers</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">)</span> <span class="o">-</span> <span class="mi">1</span> <span class="c1"># Minus the input layer</span>

    <span class="c1"># Input/Output data from the last run</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">layer_input</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">weights</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">previous_weight_delta</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="k">for</span> <span class="p">(</span><span class="n">l1</span><span class="p">,</span><span class="n">l2</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">:]):</span>
      <span class="n">w</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">normal</span><span class="p">(</span><span class="n">scale</span><span class="o">=</span><span class="mf">0.01</span><span class="p">,</span><span class="n">size</span><span class="o">=</span><span class="p">(</span><span class="n">l2</span><span class="p">,</span><span class="n">l1</span><span class="o">+</span><span class="mi">1</span><span class="p">))</span>
      <span class="c1"># lim = 4 * np.sqrt( 6 / (len(input_mask)+len(target_mask)))</span>
      <span class="c1"># lim = 0.9</span>
      <span class="c1"># w = np.random.uniform(-lim,lim,size=(l2,l1+1))</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">weights</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">w</span><span class="p">)</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">previous_weight_delta</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="n">l2</span><span class="p">,</span><span class="n">l1</span><span class="o">+</span><span class="mi">1</span><span class="p">)))</span>

<div class="viewcode-block" id="BackpropagationNetwork.shake_weights"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.bpn.BackpropagationNetwork.shake_weights">[docs]</a>  <span class="k">def</span> <span class="nf">shake_weights</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">amount</span><span class="o">=</span><span class="mf">0.1</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Shake weights (randomization). Deprecated</span>
<span class="sd">    :param amount: How much the weights should be shifted, coefficient</span>
<span class="sd">    :returns:       None</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">weights</span><span class="p">:</span>
      <span class="n">w</span> <span class="o">+=</span> <span class="n">w</span><span class="o">*</span><span class="n">amount</span></div>

<div class="viewcode-block" id="BackpropagationNetwork.run"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.bpn.BackpropagationNetwork.run">[docs]</a>  <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">inputs</span><span class="p">,</span> <span class="n">inverse_transform</span><span class="o">=</span><span class="bp">True</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Runs the neural network on inputs and return results.</span>
<span class="sd">    :param inputs: Input vector</span>
<span class="sd">    :param iverse_transform: Inversely apply the dataset scaler on the results (upscale)</span>
<span class="sd">    :returns:       Result vector</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="p">(</span><span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">scalers_fitted</span><span class="p">):</span>
      <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;No scalers prepared&quot;</span><span class="p">)</span>

    <span class="n">num_runs</span> <span class="o">=</span> <span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="c1"># Number of rows</span>

    <span class="c1"># Clear previous</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">layer_input</span>  <span class="o">=</span> <span class="p">[]</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="c1"># Run the network</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">num_layers</span><span class="p">):</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">==</span> <span class="mi">0</span><span class="p">):</span> <span class="c1"># Input (layer between input and the first hidden layer)</span>
        <span class="n">weights</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">weights</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>

        <span class="c1"># Create the input matrix by transposing the input vectors</span>
        <span class="c1"># and adding the  bias node (1.0 per input vector)</span>
        <span class="n">_input</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">vstack</span><span class="p">([</span><span class="n">inputs</span><span class="o">.</span><span class="n">T</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">,</span><span class="n">num_runs</span><span class="p">])])</span> <span class="c1"># Add bias node</span>
      <span class="k">else</span><span class="p">:</span>
        <span class="n">weights</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">weights</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
        <span class="c1"># Input is the output from the preceding layer</span>
        <span class="n">_input</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">vstack</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">,</span><span class="n">num_runs</span><span class="p">])])</span> <span class="c1"># Add bias node</span>

      <span class="c1"># The nodes&#39; attached input is the input (from the previous layer) multiplied</span>
      <span class="c1"># by the weight for that input</span>
      <span class="n">weighted_input</span> <span class="o">=</span> <span class="n">weights</span><span class="o">.</span><span class="n">dot</span><span class="p">(</span><span class="n">_input</span><span class="p">)</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">layer_input</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">weighted_input</span><span class="p">)</span>

      <span class="c1"># The nodes&#39; output is the transformed input values after</span>
      <span class="c1"># they have been sent through that node&#39;s transfer function</span>
      <span class="n">tf_output</span> <span class="o">=</span> <span class="n">tfs</span><span class="o">.</span><span class="n">tanh</span><span class="p">(</span><span class="n">weighted_input</span><span class="p">)</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">tf_output</span><span class="p">)</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">inverse_transform</span><span class="p">):</span>
      <span class="n">results</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">output_scaler</span><span class="o">.</span><span class="n">inverse_transform</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">T</span><span class="p">)</span> <span class="c1"># Append the results column</span>
      <span class="k">if</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">zero_band</span><span class="p">):</span>
        <span class="n">results</span> <span class="o">=</span> <span class="n">results</span><span class="o">.</span><span class="n">clip</span><span class="p">(</span><span class="nb">min</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="n">results</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">T</span>
    <span class="k">return</span> <span class="n">results</span></div>

<div class="viewcode-block" id="BackpropagationNetwork.train_epoch"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.bpn.BackpropagationNetwork.train_epoch">[docs]</a>  <span class="k">def</span> <span class="nf">train_epoch</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dataset</span><span class="p">,</span> <span class="n">learning_rate</span> <span class="o">=</span> <span class="mf">0.2</span><span class="p">,</span> <span class="n">momentum</span> <span class="o">=</span> <span class="mf">0.5</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Train the network for one epoch.</span>
<span class="sd">    :param dataset: Dataset which fits the network blueprint</span>
<span class="sd">    :param learning_rate: Network learning rate</span>
<span class="sd">    :param momentum: Learning momentum</span>
<span class="sd">    :returns:         Error for this epoch</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="p">(</span><span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">scalers_fitted</span><span class="p">):</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">input_scaler</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">input_scaler</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">output_scaler</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">output_scaler</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">scalers_fitted</span> <span class="o">=</span> <span class="bp">True</span>

    <span class="n">delta</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="c1"># TODO: Check if input/target masks match the dataset</span>
    <span class="n">inputs</span>  <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">training_inputs</span><span class="p">()</span>
    <span class="n">targets</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">training_targets</span><span class="p">()</span>

    <span class="n">num_runs</span> <span class="o">=</span> <span class="n">inputs</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>

    <span class="c1"># Run the network once (on all the training inputs)</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="n">inputs</span><span class="p">)</span>

    <span class="n">error</span> <span class="o">=</span> <span class="bp">None</span>
    <span class="c1"># Calculate node deltas</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">reversed</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">num_layers</span><span class="p">)):</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">num_layers</span> <span class="o">-</span> <span class="mi">1</span><span class="p">):</span> <span class="c1"># Output layer</span>
        <span class="c1"># Compare to target values to get delta values</span>
        <span class="n">output_delta</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">-</span> <span class="n">targets</span><span class="o">.</span><span class="n">T</span>
        <span class="n">error</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">output_delta</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span>
        <span class="n">delta</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">output_delta</span> <span class="o">*</span> <span class="n">tfs</span><span class="o">.</span><span class="n">tanh_derivative</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">layer_input</span><span class="p">[</span><span class="n">i</span><span class="p">]))</span>
      <span class="k">else</span><span class="p">:</span> <span class="c1"># The following layer&#39;s delta</span>
        <span class="n">delta_propagated</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">weights</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">T</span><span class="o">.</span><span class="n">dot</span><span class="p">(</span><span class="n">delta</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
        <span class="n">delta</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">delta_propagated</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">,:]</span> <span class="o">*</span> <span class="n">tfs</span><span class="o">.</span><span class="n">tanh_derivative</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">layer_input</span><span class="p">[</span><span class="n">i</span><span class="p">]))</span> <span class="c1"># Ignoring the bias nodes</span>

    <span class="c1"># Calculate weight deltas</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">num_layers</span><span class="p">):</span>
      <span class="n">di</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">num_layers</span> <span class="o">-</span> <span class="mi">1</span> <span class="o">-</span> <span class="n">i</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">==</span> <span class="mi">0</span><span class="p">):</span> <span class="c1"># Input layer</span>
        <span class="n">layer_output</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">vstack</span><span class="p">([</span><span class="n">inputs</span><span class="o">.</span><span class="n">T</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">,</span> <span class="n">num_runs</span><span class="p">])])</span>
      <span class="k">else</span><span class="p">:</span>
        <span class="n">layer_output</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">vstack</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">np</span><span class="o">.</span><span class="n">ones</span><span class="p">([</span><span class="mi">1</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">layer_output</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">]])])</span>

      <span class="n">current_weight_delta</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">layer_output</span><span class="p">[</span><span class="bp">None</span><span class="p">,:,:]</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="mi">1</span><span class="p">)</span> <span class="o">*</span> <span class="n">delta</span><span class="p">[</span><span class="n">di</span><span class="p">][</span><span class="bp">None</span><span class="p">,:,:]</span><span class="o">.</span><span class="n">transpose</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span><span class="mi">1</span><span class="p">,</span><span class="mi">0</span><span class="p">),</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

      <span class="n">weight_delta</span> <span class="o">=</span> <span class="n">learning_rate</span> <span class="o">*</span> <span class="n">current_weight_delta</span> <span class="o">+</span> <span class="n">momentum</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">previous_weight_delta</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>

      <span class="bp">self</span><span class="o">.</span><span class="n">weights</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">-=</span> <span class="n">weight_delta</span>
      <span class="bp">self</span><span class="o">.</span><span class="n">previous_weight_delta</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">weight_delta</span>

    <span class="k">return</span> <span class="n">error</span></div>

<div class="viewcode-block" id="BackpropagationNetwork.train"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.bpn.BackpropagationNetwork.train">[docs]</a>  <span class="k">def</span> <span class="nf">train</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">dataset</span><span class="p">,</span> <span class="n">learning_rate</span> <span class="o">=</span> <span class="mf">0.2</span><span class="p">,</span> <span class="n">momentum</span> <span class="o">=</span> <span class="mf">0.5</span><span class="p">,</span> <span class="n">epochs</span> <span class="o">=</span> <span class="mi">1000000</span><span class="p">,</span> <span class="n">min_err</span> <span class="o">=</span> <span class="mf">1e-3</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Train the network over several epochs.</span>
<span class="sd">    :param dataset: Dataset which fits the network blueprint</span>
<span class="sd">    :param learning_rate: Network learning rate</span>
<span class="sd">    :param momentum: Learning momentum</span>
<span class="sd">    :param epochs: Max number of epochs to train for</span>
<span class="sd">    :param min_err: Termination error</span>
<span class="sd">    :returns:       Numpy array of errors per epoch</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">errors</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">epochs</span><span class="p">):</span>
      <span class="n">error</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">train_epoch</span><span class="p">(</span><span class="n">dataset</span><span class="p">,</span> <span class="n">learning_rate</span><span class="p">,</span> <span class="n">momentum</span><span class="p">)</span>
      <span class="n">errors</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">%</span> <span class="mi">100</span> <span class="o">==</span> <span class="mi">0</span><span class="p">):</span>
        <span class="n">diffs</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="n">errors</span><span class="p">[</span><span class="o">-</span><span class="mi">100</span><span class="p">:]))</span>
        <span class="n">roc</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">diffs</span><span class="p">))</span>
        <span class="n">log</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;{0}: {1:.10f} roc: {2:.2f}&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">i</span><span class="p">,</span><span class="n">error</span><span class="p">,</span> <span class="n">roc</span><span class="p">))</span>

      <span class="k">if</span> <span class="p">(</span><span class="n">error</span> <span class="o">&lt;=</span> <span class="n">min_err</span><span class="p">):</span>
        <span class="n">log</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Reached minimum after {0} epochs&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">i</span><span class="p">))</span>
        <span class="k">break</span>

    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">errors</span><span class="p">)</span></div>

  <span class="c1"># def __getstate__(self):</span>
  <span class="c1">#   &quot;&quot;&quot; Save the network without the dataset &quot;&quot;&quot;</span>
  <span class="c1">#   d = dict(self.__dict__)</span>
  <span class="c1">#   del d[&#39;dataset&#39;] # We don&#39;t want to save the dataset with the network</span>
  <span class="c1">#   return d</span>

  <span class="c1"># def __setstate__(self, d):</span>
  <span class="c1">#   &quot;&quot;&quot; Load the network, set dataset = None &quot;&quot;&quot;</span>
  <span class="c1">#   d[&#39;dataset&#39;] = None</span>
  <span class="c1">#   self.__dict__.update(d)</span>

  <span class="k">def</span> <span class="nf">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="n">s</span> <span class="o">=</span> <span class="s2">&quot;Back Propagation Neural Network</span><span class="se">\n</span><span class="s2">&quot;</span>
    <span class="n">s</span> <span class="o">+=</span> <span class="s2">&quot;Shape: </span><span class="si">%s</span><span class="se">\n</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="nb">list</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">shape</span><span class="p">))</span>
    <span class="k">return</span> <span class="n">s</span></div>



</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>